/*
 * This file is part of CHIP8, a CHIP-8 interpreter.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#define QWERTY 1

const uint8_t font[16][5] = {
    {0xF0, 0x90, 0x90, 0x90, 0xF0}, /* 0 */
    {0x20, 0x60, 0x20, 0x20, 0x70}, /* 1 */
    {0xF0, 0x10, 0xF0, 0x80, 0xF0}, /* 2 */
    {0xF0, 0x10, 0xF0, 0x10, 0xF0}, /* 3 */
    {0x90, 0x90, 0xF0, 0x10, 0x10}, /* 4 */
    {0xF0, 0x80, 0xF0, 0x10, 0xF0}, /* 5 */
    {0xF0, 0x80, 0xF0, 0x10, 0xF0}, /* 6 */
    {0xF0, 0x10, 0x20, 0x40, 0x40}, /* 7 */
    {0xF0, 0x90, 0xF0, 0x90, 0xF0}, /* 8 */
    {0xF0, 0x90, 0xF0, 0x10, 0xF0}, /* 9 */
    {0xF0, 0x90, 0xF0, 0x90, 0x90}, /* A */
    {0xE0, 0x90, 0xE0, 0x90, 0xE0}, /* B */
    {0xF0, 0x80, 0x80, 0x80, 0xF0}, /* C */
    {0xE0, 0x90, 0x90, 0x90, 0xE0}, /* D */
    {0xF0, 0x80, 0xF0, 0x80, 0xF0}, /* E */
    {0xF0, 0x80, 0xF0, 0x80, 0x80}, /* F */
};

const uint8_t keymap_to[] = {
    0x01, 0x02, 0x03, 0x0C,
    0x04, 0x05, 0x06, 0x0D,
    0x07, 0x08, 0x09, 0x0E,
    0x0A, 0x00, 0x0B, 0x0F
};

#if QWERTY
const char keymap[] = {
    '1', '2', '3', '4',
    'q', 'w', 'e', 'r',
    'a', 's', 'd', 'f',
    'z', 'x', 'c', 'v'
};
#else
const char keymap[] = {
    '1', '2', '3', '4',
    '\'', ',', '.', 'p',
    'a', 'o', 'e', 'u',
    ';', 'q', 'j', 'k'
};
#endif
